/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2008 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * File Name: fckplugin.js
 * 	Plugin to insert "Lightbox" in the editor.
 *
 * File Authors:
 *  Akira Taniguchi (akira@behappy.2-d.jp)
 *
 * Version:
 *  2008/11/01
 */

//==============================================================================
// Lightbox Add

// Register the related command.
var oLightboxAddCommand = new FCKDialogCommand( 'LightboxAdd', FCKLang.LightboxAddDlgTitle, FCKPlugins.Items['Lightbox'].Path + 'fck_lightbox.html', 280, 330 );

oLightboxAddCommand.GetState = function()
{
	if ( FCK.EditMode != FCK_EDITMODE_WYSIWYG )
		return FCK_TRISTATE_DISABLED ;
	
	var oSel = FCKSelection.GetSelectedElement();
	
	if ( oSel == null ) return FCK_TRISTATE_DISABLED ;
	if ( typeof( oSel ) == 'undefined' ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.tagName != 'IMG' ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.getAttribute( '_fckfakelement' ) ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.src.length == 0 ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.parentNode.tagName != 'A' ) return FCK_TRISTATE_OFF ;
	if ( ! oSel.parentNode.rel ) return FCK_TRISTATE_DISABLED ;
	if ( ! oSel.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) ) return FCK_TRISTATE_DISABLED ;
	
	return FCK_TRISTATE_OFF ;
}

FCKCommands.RegisterCommand( 'LightboxAdd', oLightboxAddCommand ) ;

// Create the "LightboxAdd" toolbar button.
var oLightboxAddItem = new FCKToolbarButton( 'LightboxAdd', FCKLang.LightboxAddBtn, null, null, false, true ) ;
oLightboxAddItem.IconPath = FCKPlugins.Items['Lightbox'].Path + 'icon_add.gif' ;

FCKToolbarItems.RegisterItem( 'LightboxAdd', oLightboxAddItem ) ;

//==============================================================================
// Lightbox Del

var FCKLightboxDelCommand = function()
{
	this.Name = 'LightboxDel' ;
}

FCKLightboxDelCommand.prototype.Execute = function()
{
	if ( FCKBrowserInfo.IsGecko )
	{
		var oLink = FCKSelection.GetParentElement() ;
		if ( oLink ) 
			FCK.Selection.SelectNode( oLink ) ;
	}
	
	FCK.ExecuteNamedCommand( 'Unlink' ) ;
	
	if ( FCKBrowserInfo.IsGecko )
		FCK.Selection.Collapse( true ) ;
}

FCKLightboxDelCommand.prototype.GetState = function()
{
	if ( FCK.EditMode != FCK_EDITMODE_WYSIWYG )
		return FCK_TRISTATE_DISABLED ;
	
	var oSel = FCKSelection.GetSelectedElement();
	
	if ( oSel == null ) return FCK_TRISTATE_DISABLED ;
	if ( typeof( oSel ) == 'undefined' ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.tagName != 'IMG' ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.getAttribute( '_fckfakelement' ) ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.src.length == 0 ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.parentNode.tagName != 'A' ) return FCK_TRISTATE_DISABLED ;
	if ( ! oSel.parentNode.rel ) return FCK_TRISTATE_DISABLED ;
	if ( ! oSel.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) ) return FCK_TRISTATE_DISABLED ;
	
	return FCK_TRISTATE_OFF ;
}

var oLightboxDelCommand = new FCKLightboxDelCommand() ;

FCKCommands.RegisterCommand( 'LightboxDel', oLightboxDelCommand ) ;

// Create the "LightboxDel" toolbar button.
var oLightboxDelItem = new FCKToolbarButton( 'LightboxDel', FCKLang.LightboxDelBtn, null, null, false, true ) ;
oLightboxDelItem.IconPath = FCKPlugins.Items['Lightbox'].Path + 'icon_del.gif' ;

FCKToolbarItems.RegisterItem( 'LightboxDel', oLightboxDelItem ) ;

//==============================================================================
// Lightbox Contextmenu

// Register "LightboxAdd" and "LightboxDel" to contextmenu.
FCK.ContextMenu.RegisterListener( {
    AddItems : function( menu, tag, tagName )
    {
        // under what circumstances do we display this option
        
        var enableAdd = false ;
        var enableDel = false ;
        
        if ( tagName != 'IMG' ) return ;
		if ( tag.getAttribute( '_fckfakelement' ) ) return ;
        if ( tag.src.length == 0 ) return ;
        if ( tag.src == '' ) return ;
        
       	if ( tag.parentNode.tagName == 'A' )
       	{
			if ( tag.parentNode.rel )
				if ( tag.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) )
				{
			        enableAdd = true ;
			        enableDel = true ;
			    }
       	}
       	else
       	{
	        enableAdd = true ;
	    }
	    
        // the command needs the registered command name, the title for the context menu, and the icon path
        if ( enableAdd || enableDel )
	        menu.AddSeparator() ;
	    
        if ( enableAdd )
	        menu.AddItem( 'LightboxAdd', FCKLang.LightboxAddBtn, oLightboxAddItem.IconPath ) ;
        
        if ( enableDel )
    	    menu.AddItem( 'LightboxDel', FCKLang.LightboxDelBtn, oLightboxDelItem.IconPath ) ;
    }
} );

//==============================================================================
// Preview

FCK.Preview = function()
{
	var LightboxPath = FCKPlugins.Items['Lightbox'].Path + 'lightbox2.02/' ;

	var iWidth	= FCKConfig.ScreenWidth * 0.8 ;
	var iHeight	= FCKConfig.ScreenHeight * 0.7 ;
	var iLeft	= ( FCKConfig.ScreenWidth - iWidth ) / 2 ;
	var oWindow = window.open( '', null, 'toolbar=yes,location=no,status=yes,menubar=yes,scrollbars=yes,resizable=yes,width=' + iWidth + ',height=' + iHeight + ',left=' + iLeft ) ;

	var sHTML ;

	if ( FCKConfig.FullPage )
	{
		if ( FCK.TempBaseTag.length > 0 )
			sHTML = FCK.TempBaseTag + FCK.GetXHTML() ;
		else
			sHTML = FCK.GetXHTML() ;
	}
	else
	{
		sHTML =
			FCKConfig.DocType +
			'<html dir="' + FCKConfig.ContentLangDirection + '">' +
			'<head>' +
			FCK.TempBaseTag +
			'<title>' + FCKLang.Preview + '</title>' +
			_FCK_GetEditorAreaStyleTags() +
			'</head><body>' +
			FCK.GetXHTML() +
			'</body></html>' ;
	}

	sHTML += '<link type="text/css" rel="stylesheet" href="' + LightboxPath + 'css/lightbox.css" media="screen" charset="utf-8" />\n' ;
	sHTML += '<script type="text/javascript" src="' + LightboxPath + 'js/prototype.js" charset="utf-8"><\/script>\n' ;
	sHTML += '<script type="text/javascript" src="' + LightboxPath + 'js/effects.js" charset="utf-8"><\/script>\n' ;
	sHTML += '<script type="text/javascript" src="' + LightboxPath + 'js/lightbox.js" charset="utf-8"><\/script>\n' ;

	oWindow.document.write( sHTML );
	oWindow.document.close();
}
